#!/bin/tcsh

#if ($1 == 'CheckMD') then
#  setenv runpmemd "$AMBERHOME/bin/pmemd.cuda"
  setenv OWDIR `pwd`
#  setenv SCRDIR `pwd`
#endif

### Prep Stuff
set temp0 = "298.15"
set dt = '0.004'
cp -p $OWDIR/disang.rest ./
setenv ntwprt `tail -n 3 $OWDIR/vac.pdb | head -n 1 | awk '{printf "%s",$2}'`
setenv NumRes `tail -n 3 $OWDIR/vac.pdb | head -n 1 | awk '{printf "%s",$5}'`
if (`grep -c XXXX $OWDIR/align-z.pdb` > 0) then
 setenv Anch1 ":0"
 setenv Anch2 ":0"
 setenv Anch3 ":0"
else
  setenv Anch1 `grep 'REMARK A' $OWDIR/align-z.pdb | awk '{print $6}'`
  setenv Anch2 `grep 'REMARK A' $OWDIR/align-z.pdb | awk '{print $7}'`
  setenv Anch3 `grep 'REMARK A' $OWDIR/align-z.pdb | awk '{print $8}'`
endif
setenv NumAtm `tail -n 3 $OWDIR/vac.pdb | head -n 1 | awk '{printf "%s",$2}'`

if (-e $OWDIR/full.crds && ! `grep -c TIMINGS "$OWDIR/mini.out"` && ! `grep -c NaN "$OWDIR/mini.out"`) then
  cat << EOF > mini.in
*******************************************************
*****************************       mini.in
*******************************************************
Minimizing.
 &cntrl
  imin = 1,
  ntx = 1, 
  ntpr = 50,
  maxcyc = 1000,
  ncyc = 1000,
  irest = 0,
  ntf = 1,
  ntc = 1,
  ntb = 1,
  cut = 9.0,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3 | $Anch1 | $Anch2 | $Anch3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT

EOF
#  $runpmemd -O -p $OWDIR/full.hmr.topo -ref $OWDIR/full.crds -c $OWDIR/full.crds -i mini.in -o mini.out -r mini.rst -inf /dev/null
#  sleep 2
#  rsync -au ./ $OWDIR/
endif

#if (-e $OWDIR/mini.rst && ! `grep -c TIMINGS "$OWDIR/therm1.out"` && ! `grep -c NaN "$OWDIR/therm1.mdinfo"`) then
  cat << EOF > therm1.in
*******************************************************
*****************************       therm1.in
*******************************************************
Thermalizing, NVT.
 &cntrl
  imin = 0,
  ntx = 1,
  irest = 0,
  ntpr = 500,
  ntwr = 500,
  ntwx = 0,
  ioutfm = 1,
  iwrap = 1,
  ntf = 2,
  ntc = 2,
  cut = 9.0,
  ntt = 3,
  tempi = 10.0,
  temp0 = 10.0,
  gamma_ln = 1.0,
  ig = -1,
  ntp = 0,
  nstlim = 500,
  dt = $dt,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3 | $Anch1 | $Anch2 | $Anch3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT
  
EOF
#  $runpmemd -O -p $OWDIR/full.hmr.topo -ref $OWDIR/full.crds -c $OWDIR/mini.rst -i therm1.in -o therm1.out -r therm1.rst -inf therm1.mdinfo
#  sleep 2
#  rsync -au ./ $OWDIR/
#endif

#if ($1 == 'CheckMD') then
#  exit
#endif

#if (-e $OWDIR/therm1.rst && ! `grep -c TIMINGS "$OWDIR/therm2.out"` && ! `grep -c NaN "$OWDIR/therm2.mdinfo"`) then
  cat << EOF > therm2.in
*******************************************************
*****************************       therm2.in
*******************************************************
Thermalizing, NVT.
 &cntrl
  imin = 0,
  ntx = 5,
  irest = 1,
  ntpr = 500,
  ntwr = 25000,
  ntwx = 0,
  ioutfm = 1,
  iwrap = 1,
  ntf = 2,
  ntc = 2,
  cut = 9.0,
  ntt = 3,
  gamma_ln = 1.0,
  ig = -1,
  ntp = 0,
  nstlim = 25000,
  dt = $dt,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3 | $Anch1 | $Anch2 | $Anch3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type='TEMP0', istep1=0,    istep2=25000,  value1=10.0, value2=$temp0, /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT

EOF
#  $runpmemd -O -p $OWDIR/full.hmr.topo -ref $OWDIR/full.crds -c $OWDIR/therm1.rst -i therm2.in -o therm2.out -r therm2.rst -inf therm2.mdinfo
#  sleep 2
#  rsync -au ./ $OWDIR/
#endif

#source ./depend

#set CUR = 1
#set CUR0 = `echo $CUR | awk '{printf "%03.0f",$1}'`
#while (-e $OWDIR/therm2.rst && $CUR <= 100 && ! `grep -c TIMINGS "$OWDIR/eqnpt.100.out"` && ! `grep -c NaN "$OWDIR/eqnpt.all.out"`)
#  if ($CUR == 1) then
#    cp -pu $OWDIR/therm2.rst eqnpt.rst
#    rm -f eqnpt.all.out
#  endif
  cat << EOF > eqnpt.in
*******************************************************
*****************************       eqnpt.in
*******************************************************
Equilibrate, NPT.
 &cntrl
  imin = 0,
  ntx = 5,
  irest = 1,
  ntpr = 500,
  ntwr = 500,
  ntwx = 500,
  ioutfm = 1,
  iwrap = 1,
  ntf = 2,
  ntc = 2,
  cut = 9.0,
  ntt = 3,
  temp0 = 298.15,
  gamma_ln = 1.0,
  ig = -1,
  ntp = 1,
  barostat = 2,
  nstlim = 3500,
  dt = 0.004,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT

EOF


#  $runpmemd -O -p $OWDIR/full.hmr.topo -ref $OWDIR/full.crds -c eqnpt.rst -i eqnpt.in -o eqnpt.$CUR0.out -r eqnpt.$CUR0.rst -inf /dev/null
#  sleep 1
#  cat eqnpt.$CUR0.out >> eqnpt.all.out
#  cp eqnpt.$CUR0.rst eqnpt.rst
#  perl -p -i -e "s/default_name/eqnpt.$CUR0.rst/g" eqnpt.rst
#  if ($CUR < 100) then
#    rm eqnpt.$CUR0.*
#  else
#    cp eqnpt.100.rst rst.000
#    rsync -au ./ $OWDIR/
#  endif
#  @ CUR += 1
#  set CUR0 = `echo $CUR | awk '{printf "%03.0f",$1}'`
#end

#set nstlim = 1250000
#set ns = `echo "scale=7; $nstlim * $dt /1000" | bc | awk '{printf "%.2f",$1}'`
#set ntwe = `echo "scale=7; 1/$dt" | bc | awk '{printf "%.0f",$1}'`
#@ ntwx = $ntwe * 2
### Always print the mdin file
cat << EOF > mdin
*******************************************************
*****************************       mdin
*******************************************************
Production 5.00 ns, NPT.
 &cntrl
  imin = 0,
  ntx = 5,
  irest = 1,
  ntpr = 10000,
  ntwr = 10000,
  ntwe = 10000,
  ntxo = 1,
  ntwx = 20000,
  ntwprt = $ntwprt,
  ioutfm = 1,
  iwrap = 1,
  ntf = 2,
  ntc = 2,
  cut = 9.0,
  ntt = 3,
  temp0 = 298.15,
  gamma_ln = 1.0,
  ig = -1,
  ntp = 1,
  barostat = 2,
  nstlim = 300000,
  dt = 0.004,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT

EOF


cat << EOF > mdin2
*******************************************************
*****************************       mdin
*******************************************************
Production 5.00 ns, NPT.
 &cntrl
  imin = 0,
  ntx = 5,
  irest = 1,
  ntpr = 10000,
  ntwr = 10000,
  ntwe = 10000,
  ntxo = 1,
  ntwx = 20000,
  ntwprt = $ntwprt,
  ioutfm = 1,
  iwrap = 1,
  ntf = 2,
  ntc = 2,
  cut = 9.0,
  ntt = 3,
  temp0 = 298.15,
  gamma_ln = 1.0,
  ig = -1,
  ntp = 1,
  barostat = 2,
  nstlim = 3000000,
  dt = 0.004,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT

EOF


cat << EOF > mdin3
*******************************************************
*****************************       mdin
*******************************************************
Production 5.00 ns, NPT.
 &cntrl
  imin = 0,
  ntx = 5,
  irest = 1,
  ntpr = 10000,
  ntwr = 10000,
  ntwe = 10000,
  ntxo = 1,
  ntwx = 40000,
  ntwprt = $ntwprt,
  ioutfm = 1,
  iwrap = 1,
  ntf = 2,
  ntc = 2,
  cut = 9.0,
  ntt = 3,
  temp0 = 298.15,
  gamma_ln = 1.0,
  ig = -1,
  ntp = 1,
  barostat = 2,
  nstlim = 6000000,
  dt = 0.004,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT

EOF

cat << EOF > mdin4
*******************************************************
*****************************       mdin
*******************************************************
Production 5.00 ns, NPT.
 &cntrl
  imin = 0,
  ntx = 5,
  irest = 1,
  ntpr = 5000,
  ntwr = 5000,
  ntwe = 5000,
  ntxo = 1,
  ntwx = 5000,
  ntwprt = $ntwprt,
  ioutfm = 1,
  iwrap = 1,
  ntf = 2,
  ntc = 2,
  cut = 9.0,
  ntt = 3,
  temp0 = 298.15,
  gamma_ln = 1.0,
  ig = -1,
  ntp = 1,
  barostat = 2,
  nstlim = 25000000,
  dt = 0.004,
  ntr = 1,
  restraint_wt = 50.0,
  restraintmask = ':1-3',
  nmropt = 1,
  pencut = -1,
 /
 &wt type = 'END', /
DISANG=disang.rest
LISTOUT=POUT

EOF

exit


# MAX set as env. var. in queue script
set CYC = 1
set CHK = 0
set CUR = 1
set CUR0 = `echo $CUR | awk '{printf "%03.0f",$1}'`
set SimSEM = 99.9
set MdoutT = 0
set FinT = `echo "$StopT - $MdoutT" | bc`
while ($CUR <= $MAX && $CYC < 5 && `echo "$SimSEM > $MaxSEM" | bc` == 1 && `date +%s` < $FinT)
  if (`grep -c TIMINGS "$OWDIR/mdout.$CUR0"` && ! `grep -c NaN "$OWDIR/mdinfo.$CUR0"`) then
    if (! -e "$OWDIR/err.$CUR0") then
      cd $OWDIR/ 
      cpptraj -i pt-restraints.in >& pt-restraints.log && python ErrorEst.py $Phase $CUR0
      cd $SCRDIR/
    endif
    if (-e $OWDIR/err.$CUR0) set SimSEM = `cat $OWDIR/err.$CUR0 | awk '{printf "%s",$NF}'`
    @ CUR += 1
    set CUR0 = `echo $CUR | awk '{printf "%03.0f",$1}'`
    set CHK = 0
  else
    if ($CHK == 1) @ CYC += 1
    set PRE0 = `echo $CUR | awk '{printf "%03.0f",$1-1}'`
    $runpmemd -O -p $OWDIR/full.hmr.topo -ref $OWDIR/full.crds -c $OWDIR/rst.$PRE0 -i mdin -o mdout.$CUR0 -r rst.$CUR0 -x traj.$CUR0 -inf mdinfo.$CUR0 -e mden.$CUR0
    sleep 2
    rsync -au ./ $OWDIR/
    rm traj.$CUR0
    cd $OWDIR/
    cpptraj -i pt-restraints.in >& pt-restraints.log && python ErrorEst.py $Phase $CUR0
    cd $SCRDIR/
    if (-e $OWDIR/err.$CUR0) set SimSEM = `cat $OWDIR/err.$CUR0 | awk '{printf "%s",$NF}'`
    if (`grep -c TIMINGS "$OWDIR/mdout.$CUR0"`) set MdoutT = `grep 'Total wall time' $OWDIR/mdout.$CUR0 | sed 's/Master//g' | awk '{print $5}'`
    set FinT = `echo "$StopT - $MdoutT" | bc`
    set CHK = 1
  endif
  date
  if (`grep -c NaN "$OWDIR/mdinfo.$CUR0"`) then
    echo "Ahh NaN detected in mdinfo.$CUR0"
  endif
  echo "CYC= $CYC CHK= $CHK MAX= $MAX CUR= $CUR CUR0= $CUR0 SimSEM= $SimSEM MaxSEM= $MaxSEM StopT= $StopT MdoutT= $MdoutT FinT= $FinT"
end

cd $OWDIR
rm -r $SCRDIR

