#!/usr/bin/perl

### Inserts Dummy Atoms into the initial PDB file and prints Dummy Atom MOL2/Frcmod
#ARGS  avgmin-z.pdb GuestResName   (aligned in z-axis)
if ($#ARGV < 0){die "Args: ZAlignPDB GuestResName    (ie, align-z.pdb ADA)\n\n";}

@pdb=`cat $ARGV[0]`;

system "cat dum1.pdb | awk 'NR==2' > align-z-dum.pdb" ;
system "echo 'TER'  >> align-z-dum.pdb" ;
system "cat dum2.pdb | awk 'NR==2' >> align-z-dum.pdb" ;
system "echo 'TER'  >> align-z-dum.pdb" ;
system "cat dum3.pdb | awk 'NR==2' >> align-z-dum.pdb" ;
system "echo 'TER'  >> align-z-dum.pdb" ;


open OUT, ">>align-z-dum.pdb";

$pre=""; $resnum=3; ## expect a ++ before we start
$ter="";
foreach (@pdb){
  if ($_ !~ /ATOM |HETATM |ENDMDL|TER/){next;}
  if ($_ =~ / $ARGV[1] / && $ter eq ""){
    print OUT "TER              \n";
    @l=split " ", $_;
    printf OUT "ATOM %6s %-4s %-3s %1s %3s %11.3f %7.3f %7.3f %5.2f %5.2f\n",$l[1],$l[2],$l[3],$l[4],$l[5],$l[6],$l[7],$l[8],$l[9],$l[10];
    $ter="Res";
  }
  elsif ($_ =~ /TER/){
    print OUT "TER\n";
    $ter="Done";
  }
  elsif ($_ =~ /HOH/ && ($ter eq "Res" || $ter eq "")){
    print OUT "TER\n";
    @l=split " ", $_;
    printf OUT "ATOM %6s %-4s %-3s %1s %3s %11.3f %7.3f %7.3f %5.2f %5.2f\n",$l[1],$l[2],$l[3],$l[4],$l[5],$l[6],$l[7],$l[8],$l[9],$l[10];
    $ter="Wat";
  }
  else {
   $pre=$l[4];
   @l=split " ", $_;
   #splice(@l,4,1);  ## If you need to delete chain info
   $cur=$l[4];
   if ($pre != $cur){$resnum++;}
   printf OUT "ATOM %6s %-4s %-3s %1s %3s %11.3f %7.3f %7.3f %5.2f %5.2f\n",$l[1],$l[2],$l[3],$l[4],$l[5],$l[6],$l[7],$l[8],$l[9],$l[10];
  }
}
print OUT "END\n";
close OUT;


### Write Dummy Files
open OUT, ">dum.frcmod";
print OUT <<EOF;
Parameters for a "Lead-like" Dummy Atom
MASS
Pb     210.00

BOND

ANGLE

DIHE

IMPROPER

NONBON
  Pb       0.000     0.0000000

EOF
close OUT;

open OUT, ">dum.mol2";
print OUT <<EOF;
@<TRIPOS>MOLECULE
DUM
    1     0     1     0     1
SMALL
USER_CHARGES
@<TRIPOS>ATOM
  1 Pb      0.000000    0.000000    0.000000 Pb    1 DUM     0.0000 ****
@<TRIPOS>BOND
@<TRIPOS>SUBSTRUCTURE
      1  DUM              1 ****               0 ****  ****
EOF
close OUT;

