#!/usr/bin/perl

if ($#ARGV < 1){die "Args: RestType WinNum CD RES [nocheck|0|1]\n\nex.  u 10 BRD4 2nj \n\n";} # New Way

### Reference Distances from initial position in InitPDB
@AttachFC=qw( 0.00 0.40 0.80 1.60 2.40 4.00 5.50 8.65 11.80 18.10 24.40 37.00 49.60 74.80 100.00 );###
#@AtchFC=qw( 4.00 74.80 100.00 40.00 50.00 80.00 90.00 30.00 20.00 10.00 );###
@Translate=qw( 0.00 0.40 0.80 1.20 1.60 2.00 2.40 2.80 3.20 3.60 4.00 4.40 4.80 5.20 5.60 6.00 6.40 6.80 7.20 7.60 8.00 8.40 8.80 9.20 9.60 10.00 10.40 10.80 11.20 11.60 12.00 12.40 12.80 13.20 13.60 14.00 14.40 14.80 15.20 15.60 16.00 );###_Must_keep_spaces_between_numbers_and_parentheses!!
#@Trlate=qw( 0.00 4.00 12.80 16.00 12.00 11.00 9.00 );###_Must_keep_spaces_between_numbers_and_parentheses!!
@Rotate=qw( 80.00 70.00 60.00 50.00 40.00 30.00 20.00 10.00 0.00 -10.00 -20.00 -30.00 -40.00 );###_Must_keep_spaces_between_numbers_and_parentheses!!

### Variables Set By Args
$RestType=$ARGV[0];
$WinNum=$ARGV[1];  $JNum=sprintf "%02.0f",$WinNum;
$CD=$ARGV[2];
$gr=$ARGV[3]; $GR=uc($gr);
if ($ARGV[4] eq "nocheck"){$Check="No";}
else{$Check="Yes"; $CVD=$ARGV[4];} # CUDA_VISIBLE_DEVICES for check

$JobName="tp3nacl-$RestType"."$JNum-$CD-$gr";

## Check AMBERHOME
$AMBERHOME=`echo \$AMBERHOME`;

chomp($AMBERHOME);
if ($AMBERHOME eq ""){die "\n  AMBERHOME is not set\n";}


# Set Some Restraint Stuff
if ($RestType eq "a" || $RestType eq "l"){
  $RotAngle=$Rotate[0];
  $TransDist=$Translate[0];
  $RestWeight=$AttachFC[$WinNum];
  if ($WinNum == 0){$ScaleW=0.01*($AttachFC[$WinNum+1]/2);} # Note, ScaleW is used by ErrorEst ONLY.  Not 0.0 for a00.
  elsif ($WinNum == $#AttachFC){$ScaleW=0.01*( ($AttachFC[$WinNum]+100)/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
  else{$ScaleW=0.01*( ($AttachFC[$WinNum]+$AttachFC[$WinNum+1])/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
}
elsif ($RestType eq "r"){
  $RotAngle=$Rotate[-1];
  $TransDist=$Translate[0];
  $RestWeight=$AttachFC[$WinNum];
  if ($WinNum == 0){$ScaleW=0.01*($AttachFC[$WinNum+1]/2);}
  elsif ($WinNum == $#AttachFC){$ScaleW=0.01*( ($AttachFC[$WinNum]+100)/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
  else{$ScaleW=0.01*( ($AttachFC[$WinNum]+$AttachFC[$WinNum+1])/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
}
elsif ($RestType eq "m"){
  $RotAngle=$Rotate[0];
  $TransDist=$Translate[0];
  $RestWeight=$AttachFC[$WinNum];
  if ($WinNum == 0){$ScaleW=0.01*($AttachFC[$WinNum+1]/2);}
  elsif ($WinNum == $#AttachFC){$ScaleW=0.01*( ($AttachFC[$WinNum]+100)/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
  else{$ScaleW=0.01*( ($AttachFC[$WinNum]+$AttachFC[$WinNum+1])/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
}
elsif ($RestType eq "c"){
  $RotAngle=$Rotate[-1];
  $TransDist=$Translate[0];
  $RestWeight=$AttachFC[$WinNum];
  if ($WinNum == 0){$ScaleW=0.01*($AttachFC[$WinNum+1]/2);}
  elsif ($WinNum == $#AttachFC){$ScaleW=0.01*( ($AttachFC[$WinNum]+100)/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
  else{$ScaleW=0.01*( ($AttachFC[$WinNum]+$AttachFC[$WinNum+1])/2 - ($AttachFC[$WinNum-1]+$AttachFC[$WinNum])/2 );}
}
elsif ($RestType eq "f") {
  $TransDist=$Translate[0];
  $RotAngle=$Rotate[$WinNum];
  $RestWeight=100.00;
  $ScaleW=1.0;
}
else {# RestType eq "u"
  $RotAngle=$Rotate[0];
  $TransDist=$Translate[$WinNum];
  $RestWeight=100.00;
  $ScaleW=1.0;
}

### Manually Write tleap file for in vacuo.  Include all solvent related parameter files.
open OUT, ">tleap.in";
print OUT <<EOF;
source leaprc.gaff
source leaprc.protein.ff14SB
loadoff atomic_ions.lib
loadOff solvents.lib
HOH = SPC
WAT = SPC
loadAmberParams frcmod.spce
loadamberparams frcmod.ionsjc_spce
loadamberparams $gr.frcmod
$GR = loadmol2 $gr.mol2
loadamberparams dum.frcmod
DUM = loadmol2 dum.mol2
model = loadpdb build.pdb

check model
savepdb model vac.pdb
saveamberparm model vac.prmtop vac.crds
quit
EOF
close OUT;


# Copy Inputs
system "cp ../../setup/* ./; cp ../../pdbs/$CD-$gr.pdb ./; cp ../../pdbs/dum*.pdb ./;";
if ($GR eq "XXXX" || $GR eq "YYYY"){$twidle='my thumbs';}
else{ system "cp ../../ff/$gr.* ./;"; }

if ($RestType ne "f"){
# Insert Dummy Atom and Number Correctly
system "ln -s $CD-$gr.pdb align-z.pdb; perl SETUP-InsertDumb.pl align-z.pdb $GR";}
else { system "cp ../../pdbs/dih.$JNum.pdb ./align-z.pdb; perl SETUP-InsertDumb.pl align-z.pdb $GR";} 

# Adjust position of Guest along Z-axis
system "perl SETUP-Translate.pl align-z-dum.pdb $GR $TransDist $JNum";

# Solvate system
if ($CD eq "zzzz"){
system "$AMBERHOME/bin/tleap -s -f Solvate.in > Solvate.log";
$HMR='Yes';
if ($HMR eq "Yes"){
  open OUT, ">parmed-hmr.in";
  print OUT <<EOF;
parm full.prmtop
HMassRepartition
parmout full.hmr.prmtop
EOF
  close OUT;
  system "parmed -O -n -i parmed-hmr.in > parmed-hmr.log";
}
}
else {system "perl SETUP-Solvate.pl tleap.in $TransDist > Solvate.info";}

# Setup restraints
$Anchors = `grep 'REMARK A' $CD-$gr.pdb`; chomp($Anchors); # New Way
($REMARK,$A,$H1,$H2,$H3,$G1,$G2,$G3) = split " ",$Anchors;  # New Way
system "perl SETUP-Restraints.pl $RestType $RotAngle $RestWeight $ScaleW $H1 $H2 $H3 $G1 $G2 $G3";

system "./MD-Run.tcsh 'CheckMD' &>mdrun.log";

# Check for NaNs in short Mini and MD
#if ($Check eq "Yes"){
#  system "export CUDA_VISIBLE_DEVICES=$CVD; ./MD-Run.tcsh 'CheckMD' &>mdrun.log";
#  $CheckMD=`grep -c NaN therm1.out`; chomp($CheckMD);
#  $CheckFin=`grep -c TIMINGS therm1.out`; chomp($CheckFin);
#  $i=0;
#  system "echo '--- End of Round $i ---' >> therm1.out";
#  while ( ($CheckMD > 0 || $CheckFin < 1) && $i < 10){
#    $i++;
#    system "rm mini.* therm* mdrun.log";
#    system "perl SETUP-Solvate.pl tleap.in $TransDist > Solvate.info";
#    system "export CUDA_VISIBLE_DEVICES=$CVD; ./MD-Run.tcsh 'CheckMD' &>mdrun.log";
#    $CheckMD=`grep -c NaN therm1.out`; chomp($CheckMD);
#    $CheckFin=`grep -c TIMINGS therm1.out`; chomp($CheckFin);
#    system "echo '--- End of Round $i ---' >> therm1.out";
#  }
#  if ($i >= 10){print "README: COULD NOT MINI/THERM1 $CD-$gr";}
#}


# Make a restraint processing file
open OUT, ">pt-rstcombine.in";
print OUT "noexitonerror\nparm full.topo\n";
for $i (1..200){
  printf OUT "trajin rst.%03.0f\n",$i;
}
print OUT "trajout traj.rsts netcdf\n";
close OUT;

# Write PBS Submission Scripts
if ($RestType eq "a" && $WinNum == 0){$Max=200;$Phase="a";$MaxSEM="0.0";}
elsif ($RestType eq "r" && $WinNum == 0){$Max=200;$Phase="r";$MaxSEM="0.0";}
elsif ($RestType eq "m" && $WinNum == 0){$Max=200;$Phase="m";$MaxSEM="0.0";}
elsif ($RestType eq "f" && $WinNum == 0){$Max=50;$Phase="f";$MaxSEM="0.0";}
elsif ($RestType eq "a"){$Max=10;$Phase="a";$MaxSEM=0.02;}
elsif ($RestType eq "r"){$Max=10;$Phase="r";$MaxSEM=0.02;}
elsif ($RestType eq "u"){$Max=10;$Phase="u";$MaxSEM=0.1;}
else{$max=1;}

#system "perl -p -i -e 's/MAXXX/$Max/g' Batch-MD-Run.tcsh";
#system "perl -p -i -e 's/PhaseXXX/$Phase/g' Batch-MD-Run.tcsh";
#system "perl -p -i -e 's/MaxSEMXXX/$MaxSEM/g' Batch-MD-Run.tcsh";


open OUT, ">ts.sub";
print OUT <<EOF;
#!/bin/tcsh
#PBS -l walltime=08:00:00,nodes=1:ppn=3:gpu -q glean
#PBS -j oe -r n -m a -M shireham\@gmail.com
#PBS -N TS-$JobName

### Set Some Vars
setenv MAX $Max
setenv Phase $Phase
setenv MaxSEM $MaxSEM
setenv subfile "ts.sub"
module swap intel gnu
module load python
module load scipy/2.7
setenv PATH "/home/henrikse/gnu44-bin:/opt/mvapich2/gnu/ib/bin:\$PATH"
if (\$?CUDA_VISIBLE_DEVICES) then
  if (`nvidia-smi | egrep -c 'GTX 680|GTX 780'` > 0) then
    module load cuda
    setenv CUDA_HOME \$CUDAHOME
    setenv LD_LIBRARY_PATH "\${CUDA_HOME}/lib64:/opt/mvapich2/gnu/ib/lib:\$LD_LIBRARY_PATH"
    source /home/henrikse/amber14gnu/amber.csh
  else
    setenv CUDA_HOME "/opt/cuda/7.5.18"
    setenv LD_LIBRARY_PATH "\${CUDA_HOME}/lib64:/opt/mvapich2/gnu/ib/lib:\$LD_LIBRARY_PATH"
    source /home/henrikse/amber14gnu-faster/amber.csh
  endif
  setenv runpmemd \$AMBERHOME/bin/pmemd.cuda
  setenv SCRDIR \$TMPDIR
else
  setenv runpmemd "mpiexec.hydra -f \$PBS_NODEFILE -np \$PBS_NP \$AMBERHOME/bin/pmemd.MPI"  #### CHECK THIS!!
  setenv SCRDIR /oasis/tscc/scratch/henrikse/tmp/\$PBS_JOBID
endif
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
setenv OWDIR \$PBS_O_WORKDIR
setenv WallSec \$PBS_WALLTIME
setenv StartT `date +%s`
setenv StopT `echo "\$StartT + \$WallSec" | bc`

### OWDIR Stuff
cd \$OWDIR/
env > node.info 
if (\$?CUDA_VISIBLE_DEVICES) then
  nvidia-smi >> node.info
  echo "ssh \$HOSTNAME 'cd \$SCRDIR; ll -tr; cat therm2.mdinfo'" >> node.info
else
  echo "ssh \$HOSTNAME" >> node.info
  echo "ll -tr \$SCRDIR; cat \$SCRDIR/therm2.mdinfo" >> node.info
endif
mkdir -p \$SCRDIR

### Determine Current Restart Level and Cycle Value
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
# CYCLE = 1
set CYC = `grep -m 1 CYCLE \$subfile | awk '{printf "%s",\$4}'`
@ NCYC = \$CYC + 1

### Execute MD-Run.tcsh
if (\$CUR > \$MAX) then
  echo "Finished to CUR > \$MAX!"
else if (\$CUR == 1 && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `qsub -W depend=afterany:\$PBS_JOBID \$subfile`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (! -e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = 1/g" \$subfile
  setenv DAUGHTER `qsub -W depend=afterany:\$PBS_JOBID \$subfile`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (-e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `qsub -W depend=afterany:\$PBS_JOBID \$subfile`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (\$CYC >= 5) then
  echo "Too many cycling repeats.  Check job!"
else
  echo "I did not anticipate this situation!!"
endif

### Determine Current Restart Level, SimSEM, and Kill Daughter and Self appropriately
cd \$OWDIR
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
if (! -e err.\$PRE0) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  cpptraj -i pt-restraints.in >& pt-restraints.log
  python ErrorEst.py \$Phase \$PRE0
endif
set SimSEM = `cat err.\$PRE0 | awk '{printf "%s",\$NF}'`
if (`echo "\$SimSEM > \$MaxSEM" | bc` == 0) then
  qdel \$DAUGHTER
endif
rm -r \$SCRDIR
qdel \$PBS_JOBID

EOF
close OUT;

open OUT, ">tsg.sub";
print OUT <<EOF;
#!/bin/tcsh
#PBS -l walltime=72:00:00,nodes=1:ppn=2:gpu -q home-gibbs
#PBS -j oe -r n -m a -M shireham\@gmail.com
#PBS -N TSG-$JobName

### Set Some Vars
setenv MAX $Max
setenv Phase $Phase
setenv MaxSEM $MaxSEM
setenv subfile "ts.sub"
module swap intel gnu
module load python
module load scipy/2.7
setenv PATH "/home/henrikse/gnu44-bin:/opt/mvapich2/gnu/ib/bin:\$PATH"
if (\$?CUDA_VISIBLE_DEVICES) then
  if (`nvidia-smi | egrep -c 'GTX 680|GTX 780'` > 0) then
    module load cuda
    setenv CUDA_HOME \$CUDAHOME
    setenv LD_LIBRARY_PATH "\${CUDA_HOME}/lib64:/opt/mvapich2/gnu/ib/lib:\$LD_LIBRARY_PATH"
    source /home/henrikse/amber14gnu/amber.csh
  else
    setenv CUDA_HOME "/opt/cuda/7.5.18"
    setenv LD_LIBRARY_PATH "\${CUDA_HOME}/lib64:/opt/mvapich2/gnu/ib/lib:\$LD_LIBRARY_PATH"
    source /home/henrikse/amber14gnu-faster/amber.csh
  endif
  setenv runpmemd \$AMBERHOME/bin/pmemd.cuda
  setenv SCRDIR \$TMPDIR
else
  setenv runpmemd "mpiexec.hydra -f \$PBS_NODEFILE -np \$PBS_NP \$AMBERHOME/bin/pmemd.MPI"  #### CHECK THIS!!
  setenv SCRDIR /oasis/tscc/scratch/henrikse/tmp/\$PBS_JOBID
endif
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
setenv OWDIR \$PBS_O_WORKDIR
setenv WallSec \$PBS_WALLTIME
setenv StartT `date +%s`
setenv StopT `echo "\$StartT + \$WallSec" | bc`

### OWDIR Stuff
cd \$OWDIR/
env > node.info
if (\$?CUDA_VISIBLE_DEVICES) then
  nvidia-smi >> node.info
  echo "ssh \$HOSTNAME 'cd \$SCRDIR; ll -tr; cat therm2.mdinfo'" >> node.info
else
  echo "ssh \$HOSTNAME" >> node.info
  echo "ll -tr \$SCRDIR; cat \$SCRDIR/therm2.mdinfo" >> node.info
endif
mkdir -p \$SCRDIR

### Determine Current Restart Level and Cycle Value
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
# CYCLE = 1
set CYC = `grep -m 1 CYCLE \$subfile | awk '{printf "%s",\$4}'`
@ NCYC = \$CYC + 1

### Execute MD-Run.tcsh
if (\$CUR > \$MAX) then
  echo "Finished to CUR > \$MAX!"
else if (\$CUR == 1 && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `qsub -W depend=afterany:\$PBS_JOBID \$subfile`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (! -e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = 1/g" \$subfile
  setenv DAUGHTER `qsub -W depend=afterany:\$PBS_JOBID \$subfile`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (-e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `qsub -W depend=afterany:\$PBS_JOBID \$subfile`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (\$CYC >= 5) then
  echo "Too many cycling repeats.  Check job!"
else
  echo "I did not anticipate this situation!!"
endif

### Determine Current Restart Level, SimSEM, and Kill Daughter and Self appropriately
cd \$OWDIR
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
if (! -e err.\$PRE0) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  cpptraj -i pt-restraints.in >& pt-restraints.log
  python ErrorEst.py \$Phase \$PRE0
endif
set SimSEM = `cat err.\$PRE0 | awk '{printf "%s",\$NF}'`
if (`echo "\$SimSEM > \$MaxSEM" | bc` == 0) then
  qdel \$DAUGHTER
endif
rm -r \$SCRDIR
qdel \$PBS_JOBID

EOF
close OUT;

open OUT, ">ct.sub";
print OUT <<EOF;
#!/bin/tcsh
#\$ -cwd -V -m a -M shireham\@gmail.com
#\$ -l h_rt=03:00:00 -l gpu=1 -q all.q
#\$ -S /bin/tcsh -j y -N CT-$JobName 

### Sleep a little, hopefully avoid jobs starting simultaneously
set interval = `perl -e 'srand; print int(rand(100)+1)'`
sleep \$interval

### Set Some Vars
setenv OWDIR \$SGE_O_WORKDIR
setenv MAX $Max
setenv Phase $Phase
setenv MaxSEM $MaxSEM
setenv subfile "ct.sub"
setenv CUDA_HOME /soft/pkg/cuda-5.0
setenv LD_LIBRARY_PATH "\$CUDA_HOME/lib64:\$LD_LIBRARY_PATH"
setenv PYTHONPATH "/home/henrikse/python-modules/lib64/python"
source /home/henrikse/amber14gnu/amber.csh
setenv runpmemd "\$AMBERHOME/bin/pmemd.cuda"
setenv CUDA_VISIBLE_DEVICES "0,1,2,3"
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
setenv OWDIR \$SGE_O_WORKDIR
setenv SCRDIR `mktemp -d /scratch/henrikse.XXXXXX`
setenv WallSec 10800
setenv StartT `date +%s`
setenv StopT `echo "\$StartT + \$WallSec" | bc`

### OWDIR Stuff
cd \$OWDIR/
env > node.info 
echo "ssh \$HOSTNAME 'cd \$SCRDIR; ll -tr; cat therm2.mdinfo'" >> node.info
mkdir -p \$SCRDIR

### Determine Current Restart Level and Cycle Value
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
# CYCLE = 1
set CYC = `grep -m 1 CYCLE \$subfile | awk '{printf "%s",\$4}'`
@ NCYC = \$CYC + 1

### Execute MD-Run.tcsh
if (\$CUR > \$MAX) then
  echo "Finished to CUR > \$MAX!"
else if (\$CUR == 1 && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `ssh gpu.ctbp.ucsd.edu "cd \$SGE_O_WORKDIR; qsub -hold_jid \$JOB_ID \$subfile" | awk '{print \$3}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (! -e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = 1/g" \$subfile
  setenv DAUGHTER `ssh gpu.ctbp.ucsd.edu "cd \$SGE_O_WORKDIR; qsub -hold_jid \$JOB_ID \$subfile" | awk '{print \$3}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (-e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `ssh gpu.ctbp.ucsd.edu "cd \$SGE_O_WORKDIR; qsub -hold_jid \$JOB_ID \$subfile" | awk '{print \$3}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (\$CYC >= 5) then
  echo "Too many cycling repeats.  Check job!"
else
  echo "I did not anticipate this situation!!"
endif

### Determine Current Restart Level, SimSEM, and Kill Daughter and Self appropriately
cd \$OWDIR
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
if (! -e err.\$PRE0) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  cpptraj -i pt-restraints.in >& pt-restraints.log
  python ErrorEst.py \$Phase \$PRE0
endif
set SimSEM = `cat err.\$PRE0 | awk '{printf "%s",\$NF}'`
if (`echo "\$SimSEM > \$MaxSEM" | bc` == 0 || ! -e err.\$PRE0) then
  ssh gpu.ctbp.ucsd.edu "qdel \$DAUGHTER"
endif
rm -r \$SCRDIR
ssh gpu.ctbp.ucsd.edu "qdel \$JOB_ID"

EOF
close OUT;

open OUT, ">st.sub";
print OUT <<EOF;
#!/bin/tcsh
#SBATCH -A TG-MCB140021
#SBATCH -J ST-$JobName
#SBATCH -o ST-logfile.o%j
#SBATCH --mail-type=FAIL
#SBATCH --mail-user=shireham\@gmail.com
#SBATCH -n 16
#SBATCH -p gpu
#SBATCH -t 24:00:00


### Set Some Vars
setenv MAX $Max
setenv Phase $Phase
setenv MaxSEM $MaxSEM
setenv subfile "st.sub"
setenv runpmemd \$AMBERHOME/bin/pmemd.cuda
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
setenv OWDIR \$SLURM_SUBMIT_DIR
setenv SCRDIR "/scratch/01168/henrikse/scratchfolders/job-\$SLURM_JOBID"
setenv WallSec `echo "\$SLURM_TACC_RUNLIMIT_MINS * 60" | bc`
setenv StartT `date +%s`
setenv StopT `echo "\$StartT + \$WallSec" | bc`

### OWDIR Stuff
cd \$OWDIR/
env > node.info 
mkdir -p \$SCRDIR

### Determine Current Restart Level and Cycle Value
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
# CYCLE = 1
set CYC = `grep -m 1 CYCLE \$subfile | tail -n 1 | awk '{printf "%s",\$4}'`
@ NCYC = \$CYC + 1

### Execute MD-Run.tcsh
if (\$CUR > \$MAX) then
  echo "Finished to CUR > \$MAX!"
else if (\$CUR == 1 && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `ssh henrikse\@login3.stampede.tacc.utexas.edu "cd \$SLURM_SUBMIT_DIR ; sbatch -d afterany:\$SLURM_JOBID \$subfile" | tail -n 1 | awk '{printf \$4}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (! -e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = 1/g" \$subfile
  setenv DAUGHTER `ssh henrikse\@login3.stampede.tacc.utexas.edu "cd \$SLURM_SUBMIT_DIR ; sbatch -d afterany:\$SLURM_JOBID \$subfile" | tail -n 1 | awk '{printf \$4}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (-e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `ssh henrikse\@login3.stampede.tacc.utexas.edu "cd \$SLURM_SUBMIT_DIR ; sbatch -d afterany:\$SLURM_JOBID \$subfile" | tail -n 1 | awk '{printf \$4}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (\$CYC >= 5) then
  echo "Too many cycling repeats.  Check job!"
else
  echo "I did not anticipate this situation!!"
endif

### Determine Current Restart Level, SimSEM, and Kill Daughter and Self appropriately
cd \$OWDIR
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
if (! -e err.\$PRE0) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  cpptraj -i pt-restraints.in >& pt-restraints.log
  python ErrorEst.py \$Phase \$PRE0
endif
set SimSEM = `cat err.\$PRE0 | awk '{printf "%s",\$NF}'`
if (`echo "\$SimSEM > \$MaxSEM" | bc` == 0 || ! -e err.\$PRE0) then
  ssh henrikse\@login3.stampede.tacc.utexas.edu "scancel \$DAUGHTER"
endif
rm -r \$SCRDIR
ssh henrikse\@login3.stampede.tacc.utexas.edu "scancel \$SLURM_JOBID"

EOF
close OUT;


open OUT, ">cm.sub";
print OUT <<EOF;
#!/bin/tcsh
#SBATCH -A TG-MCB140021
#SBATCH -J CM-$JobName
#SBATCH -o CM-logfile.o%j
#SBATCH --mail-type=FAIL
#SBATCH --mail-user=shireham\@gmail.com
#SBATCH -n 6
#SBATCH --gres=gpu:1
#SBATCH -p gpu-shared
#SBATCH -t 48:00:00


### Set Some Vars
setenv MAX $Max
setenv Phase $Phase
setenv MaxSEM $MaxSEM
setenv subfile "cm.sub"
module swap intel gnu
module load cuda
module load scipy/2.7
module load mvapich2_ib/2.1
module load python
source /home/henrikse/amber14gnu/amber.csh
setenv runpmemd \$AMBERHOME/bin/pmemd.cuda
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
setenv OWDIR \$SLURM_SUBMIT_DIR
setenv SCRDIR "/scratch/\$USER/\$SLURM_JOB_ID"
setenv WallSec `grep '#SBATCH -t' \$OWDIR/cm.sub | sed 's/:/ /g' | awk '{printf "%.0f",\$3*3600+\$4*60+\$5}'`
setenv StartT `date +%s`
setenv StopT `echo "\$StartT + \$WallSec" | bc`

### OWDIR Stuff
cd \$OWDIR/
env > node.info
mkdir -p \$SCRDIR

### Determine Current Restart Level and Cycle Value
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
# CYCLE = 3
set CYC = `grep -m 1 CYCLE \$subfile | tail -n 1 | awk '{printf "%s",\$4}'`
@ NCYC = \$CYC + 1

### Execute MD-Run.tcsh
if (\$CUR > \$MAX) then
  echo "Finished to CUR > \$MAX!"
else if (\$CUR == 1 && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `ssh henrikse\@comet-ln2.sdsc.edu "cd \$SLURM_SUBMIT_DIR ; sbatch -d afterany:\$SLURM_JOBID \$subfile" | tail -n 1 | awk '{printf \$4}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (! -e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = 1/g" \$subfile
  setenv DAUGHTER `ssh henrikse\@comet-ln2.sdsc.edu "cd \$SLURM_SUBMIT_DIR ; sbatch -d afterany:\$SLURM_JOBID \$subfile" | tail -n 1 | awk '{printf \$4}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (-e mdout.\$CUR0 && `grep -c TIMINGS mdout.\$PRE0` && \$CYC < 5) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  setenv DAUGHTER `ssh henrikse\@comet-ln2.sdsc.edu "cd \$SLURM_SUBMIT_DIR ; sbatch -d afterany:\$SLURM_JOBID \$subfile" | tail -n 1 | awk '{printf \$4}'`
  echo "Daughter ID= \$DAUGHTER"
  cd \$SCRDIR/
  \$OWDIR/MD-Run.tcsh
else if (\$CYC >= 5) then
  echo "Too many cycling repeats.  Check job!"
else
  echo "I did not anticipate this situation!!"
endif

### Determine Current Restart Level, SimSEM, and Kill Daughter and Self appropriately
cd \$OWDIR
set CUR = 1
set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
while (`grep -c TIMINGS mdout.\$CUR0` && ! `grep -c NaN mdinfo.\$CUR0`)
  @ CUR += 1
  set CUR0 = `echo \$CUR | awk '{printf "%03.0f",\$1}'`
end
set PRE0 = `echo \$CUR | awk '{printf "%03.0f",\$1-1}'`
if (! -e err.\$PRE0) then
  perl -p -i -e "s/^# CYCLE = \$CYC/# CYCLE = \$NCYC/g" \$subfile
  cpptraj -i pt-restraints.in >& pt-restraints.log
  python ErrorEst.py \$Phase \$PRE0
endif
set SimSEM = `cat err.\$PRE0 | awk '{printf "%s",\$NF}'`
if (`echo "\$SimSEM > \$MaxSEM" | bc` == 0 || ! -e err.\$PRE0) then
  ssh henrikse\@comet-ln2.sdsc.edu "scancel \$DAUGHTER" 
endif
rm -r \$SCRDIR
ssh henrikse\@comet-ln2.sdsc.edu "scancel \$SLURM_JOBID"

EOF
close OUT;


open OUT, ">local.tcsh";
print OUT <<EOF;
#!/bin/tcsh


setenv MAX $Max
setenv Phase $Phase
setenv MaxSEM $MaxSEM
setenv CUDA_VISIBLE_DEVICES \$1
setenv runpmemd "\$AMBERHOME/bin/pmemd.cuda"
setenv OWDIR `pwd`
setenv SCRDIR "\$OWDIR/scratchdir"
### Walltime is 1 Week
setenv WallSec 604800
setenv StartT `date +%s`
setenv StopT `echo "\$StartT + \$WallSec" | bc`
mkdir -p \$SCRDIR
env > node.info

cd \$SCRDIR/
\$OWDIR/MD-Run.tcsh

sleep 5
cd \$OWDIR
rsync -au --progress \$SCRDIR/ ./
rm -r \$SCRDIR

EOF
close OUT;

system "chmod u+x local.tcsh";

